// js_console.js - code for the JavaScript Console
// Copyright 2009, Martin Rinehart

out_area = document.getElementById( 'output' );
in_area = document.getElementById( 'input' );
details = document.getElementById( 'details' );

initial_out = true; // out == '&nbsp;'
edetails = false; // do not show full error details

document.captureEvents( Event.KEYPRESS );
document.onkeypress = function( e ) {
    
    e = e || event; // standards or MSIE
    if ( e.keyCode == 13 ) {
        local_eval();
    }
}

function clear_all() { clear_in(); clear_out(); }
function clear_in() { in_area.value = ''; }
function clear_out() { out_area.innerHTML = '&nbsp;'; initial_out = true; }

function show_details() {
    if ( edetails ) {
        details.innerHTML = 'Details On';
        edetails = false;
    } else {
        details.innerHTML = 'Details Off';
        edetails = true;
    }
}

function latest( str ) {
    arr = str.split( '\n\r' ); // PC only!
    return arr[ arr.length - 1 ];
}

function local_eval() {
    try {
        out = eval( latest(in_area.value) );
        if ( initial_out ) {
            out_area.innerHTML = '';
            initial_out = false;
        }
        out_area.innerHTML += out + '<br>';
    }
    catch ( e ) {
        msg = e.name;
        if ( edetails ) msg += e.message;
        out_area.innerHTML += msg + '<br>';
    }
}   
 
function save() {
    alert( 'A thousand apologies, my friend.\n\n'+
            'For security, JavaScript is not allowed\n'+
            'to perform File I/O.\n\n'+
            'May I suggest cut/paste between file\n'+
            'and input window?'
        )
}        

// end of js_console.js